Description

History

#2 - 03/16/2023 07:00 AM - Constantin Asofiei

You can have the same f1 shared frame defined in two programs, but with different widgets:

program A:

def shared frame f1.

def var ch as char.

display ch with frame f1.

program B:

def shared frame f1.

def var v1 as char.

display v1 with frame f1.

FWD creates only one shared frame (for program A), and this is being used for program B (incorrectly).

#3 - 03/17/2023 09:14 AM - Greg Shah

Is the issue that we need a 2nd frame or just that we are incorrectly using the frame?

#4 - 03/17/2023 10:39 AM - Constantin Asofiei

- Status changed from New to WIP
- Assignee set to Constantin Asofiei

Greg Shah wrote:

Is the issue that we need a 2nd frame or just that we are incorrectly using the frame?

 

I'm not sure yet, I need to do some more tests.

#5 - 03/17/2023 01:13 PM - Constantin Asofiei

The example programs for this task are incorrect: they both give This ** Shared frame f1 field v1 must first appear in a FORM statement. (890)

compile error in 4GL.

Looking again at the original application source code, at least one file has no FORM statement for the DEF SHARED FRAME .

#6 - 03/17/2023 01:27 PM - Constantin Asofiei

A recreated bug is this:

first program defines a shared frame but it doesn't use it:

def temp-table tt1 field f1 as int.

define shared frame   f1.

form tt1 with frame f1.

second program uses the same shared frame:

def temp-table tt1 field f1 as int.

define shared frame   f1.

form tt1 with frame f1.

display tt1 with frame f1.

This causes the shared frame interface to become 'empty' because first program thinks is no longer used.
#7 - 03/21/2023 11:25 AM - Constantin Asofiei

- Status changed from WIP to Review

- % Done changed from 0 to 100

This is fixed in 7199a rev 14511.

#8 - 03/21/2023 06:32 PM - Greg Shah

- Status changed from Review to Test

Code Review Task Branch 7199a Revision 14511

No objections.

#9 - 03/24/2023 12:42 PM - Constantin Asofiei

7199a was merged to trunk rev 14514 and archived.

#10 - 03/27/2023 04:18 AM - Greg Shah

- Status changed from Test to Closed

#11 - 05/01/2023 10:11 AM - Constantin Asofiei

The fix for this 'unused shared frame' must apply to NEW SHARED frames, too.  Fixed in 7199c/14567

#12 - 05/02/2023 08:52 AM - Greg Shah

Code Review Task Branch 7199c Revision 14567

No objections.

#13 - 06/05/2023 10:28 AM - Constantin Asofiei

7199c was merged to trunk rev 14610 and archived.
